<template>
  <v-card class="mx-auto" max-width="500">
    <v-container fluid>
      <v-row dense>
        <v-col>
          <v-card>
            <v-img
              :src="img"
              class="align-end"
              gradient="to bottom, rgba(0,0,0,.1), rgba(0,0,0,.5)"
              height="200px"
              cover
              v-if="img !== ''"
            >
              <v-card-title class="text-white">
                <h4 class="text-white">
                  {{ title | upperCase }}
                </h4>
              </v-card-title>
            </v-img>
            <v-skeleton-loader
              v-else
              height="240"
              type="image, list-item-two-line"
            />

            <v-card-actions>
              <v-spacer />
              <v-btn size="small" icon density="compact" variant="text" @click="onMoreInformation()">
                <v-icon>mdi-information</v-icon>
              </v-btn>
              <v-btn size="small" icon density="compact" variant="text">
                <v-icon>mdi-heart</v-icon>
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-col>
      </v-row>
    </v-container>
  </v-card>
</template>
<script>
// import PokemonMixin from "@/mixins/PokemonMixins.js";
export default {
  name: "pokemon",
  props: {
    id: {
    },
    img: {
      type: String,
      default: () => "",
    },
    title: {
      type: String,
      default: () => "",
    },
  },
  //   mixins: [PokemonMixin],
  filters: {
    upperCase(value) {
      if (!value) return "";
      // Si la variable es diferente de string
      if (typeof value !== "string") {
        return value;
      }
      // El valor contiene caracteres especiales que no se pueden convertir a mayúsculas
      if (/[^a-zA-Z\s]/.test(value)) {
        return value;
      }
      return value.toUpperCase();
    },
  },
  methods: {
    onMoreInformation() {
      this.$emit("onMoreInformation", this.title);
    },
  },
};
</script>